import cPickle as pickle
from os.path import join
from optparse import OptionParser
import subprocess
import os, sys
import multiprocessing as mp
import time
import shutil
import json
import csv

csv.field_size_limit(sys.maxsize)

cwd = os.getcwd()

def merge_dicts(*dict_args):
    result = {}
    for dictionary in dict_args:
        result.update(dictionary)
    return result

def csv_length():
	with open(join(cwd,"Temp_CSV","temporary.csv")) as csvDataFile:
		csvReader = csv.reader(csvDataFile)
		row_count = sum(1 for row in csvReader)
	return row_count

def read_csv(chunk,chunk_size):
	csv_dictonary = {}
	count = 0
	start = chunk*chunk_size

	with open(join(cwd,"Temp_CSV","temporary.csv")) as csvDataFile:
		csvReader = csv.reader(csvDataFile)
		for row in csvReader:
			if count >= start:
				csv_dictonary[row[0]] = row[4]
			if len(csv_dictonary) == chunk_size:
				return csv_dictonary
			count += 1	
	return csv_dictonary



def check_chain_correctness(pos_num, amino, chain):
		if pos_num in chain:
			if chain[pos_num][amino] != 0:
				return True
			else:
				return None
		else:
			return None


def checking_sequence_correctness(numbers,reference):
	"""
	This function runs every residue/position against
	the reference matrix. If a residue position not found
	in the refence matrix it is flagged.
	"""
	incorrect_positions = []
	current_error = 0
	for frame in numbers:
		for pos_num in numbers[frame]:
			if numbers[frame][pos_num] == "-":
				continue
			
			else:
				if int(pos_num[:3]) < 27:
					if check_chain_correctness(pos_num, numbers[frame][pos_num], reference["f1"]) == True:
						pass
					else:
						current_error +=1
						incorrect_positions.append((pos_num, numbers[frame][pos_num]))

				elif int(pos_num[:3]) < 39:
					if check_chain_correctness(pos_num, numbers[frame][pos_num], reference["c1"]) == True:
						pass
					else:
						current_error +=1
						incorrect_positions.append((pos_num, numbers[frame][pos_num]))

				elif int(pos_num[:3]) < 56:
					if check_chain_correctness(pos_num, numbers[frame][pos_num], reference["f2"]) == True:
						pass
					else:
						current_error +=1
						incorrect_positions.append((pos_num, numbers[frame][pos_num]))

				elif int(pos_num[:3]) < 66:
					if check_chain_correctness(pos_num, numbers[frame][pos_num], reference["c2"]) == True:
						pass
					else:
						current_error +=1
						incorrect_positions.append((pos_num, numbers[frame][pos_num]))

				elif int(pos_num[:3]) < 105:
					if check_chain_correctness(pos_num, numbers[frame][pos_num], reference["f3"]) == True:
						pass
					else:
						current_error +=1
						incorrect_positions.append((pos_num, numbers[frame][pos_num]))

				elif int(pos_num[:3]) < 118:
					if check_chain_correctness(pos_num, numbers[frame][pos_num], reference["c3"]) == True:
						pass
					else:
						current_error +=1
						incorrect_positions.append((pos_num, numbers[frame][pos_num]))


				elif int(pos_num[:3]) >= 118:
					if check_chain_correctness(pos_num, numbers[frame][pos_num], reference["f4"]) == True:
						pass
					else:
						current_error +=1
						incorrect_positions.append((pos_num, numbers[frame][pos_num]))
	if incorrect_positions == []:
		incorrect_positions.append(None)

	return current_error, incorrect_positions

def initiating_ref_matrix(passed_new_lines, reference_matrix,core):
	all_regions_aa = {}
	correct_sequences = {}
	for line in passed_new_lines:
		
		aa = json.loads(passed_new_lines[line])


		error, incorrect_residues = checking_sequence_correctness(aa,reference_matrix)  # Here I pass sequence to a reference matrix
		if error not in correct_sequences:
			correct_sequences[error]= {}
			all_regions_aa[error] = {}
		if line in correct_sequences[error]:
			continue
		else:
			if type(redundant_lines[line]) == int:
				multiplication_factor = redundant_lines[line]
			else:
				multiplication_factor = len(redundant_lines[line])
			correct_sequences[error][line] = (multiplication_factor, incorrect_residues)
	print "Portion %d has finished" %(core+1)

	return correct_sequences


def flagResiduePositions(cores, startingData,antibodychain):
	global redundant_lines
	global chain
	
	redundant_lines = startingData
	chain = antibodychain

	reference_matrix = {}
	if chain == "H":
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwh1"), "rb") as m:
			reference_matrix["f1"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwh2"), "rb") as m:
			reference_matrix["f2"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwh3"), "rb") as m:
			reference_matrix["f3"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwh4"), "rb") as m:
			reference_matrix["f4"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("cdrh1"), "rb") as m:
			reference_matrix["c1"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("cdrh2"), "rb") as m:
			reference_matrix["c2"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("cdrh3"), "rb") as m:
			reference_matrix["c3"] = pickle.load(m).transpose()

	if chain == "L":
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwl1"), "rb") as m:
			reference_matrix["f1"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwl2"), "rb") as m:
			reference_matrix["f2"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwl3"), "rb") as m:
			reference_matrix["f3"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("fwl4"), "rb") as m:
			reference_matrix["f4"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("cdrl1"), "rb") as m:
			reference_matrix["c1"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("cdrl2"), "rb") as m:
			reference_matrix["c2"] = pickle.load(m).transpose()
		with open("Reference_matrix/reference_matrix_%s.pkl" % ("cdrl3"), "rb") as m:
			reference_matrix["c3"] = pickle.load(m).transpose()

	correct_sequences = {}
	count = 0
	all_regions_aa = {}
	##############################################################################
	# Here I need to add a for loop that collect all parsed_reads_raw_num_%d.pkl #
	##############################################################################
	t1 = time.time()
	temp_csv_length = csv_length()
	chunk_size = 500000
	number_of_chunks = temp_csv_length/ chunk_size +1
	for chunk in range(number_of_chunks):
		new_lines = read_csv(chunk,chunk_size)
		print "The Current analysed file is %s" %(chunk)
		num_of_entries = len(new_lines)
		print "The total number of unique entries is %d" %(num_of_entries)

		#################################
		## ABOSS is parallelized now ####
		#################################

		pool = mp.Pool(processes=cores)

		items_sort = new_lines.items()

		results = [ pool.apply_async(initiating_ref_matrix, args = (dict(items_sort[i::cores]), reference_matrix,i)) for i in xrange(cores) ]
		del items_sort

		filtered_sequences_portion = [ r.get() for r in results ]
		pool.close()
		del results	
		
		for portion in range(len(filtered_sequences_portion)):

			for error in filtered_sequences_portion[portion]:
				if error not in all_regions_aa:
					all_regions_aa[error] = {}
					correct_sequences[error] = {}

				correct_sequences[error] = merge_dicts(correct_sequences[error],filtered_sequences_portion[portion][error])

				for sequence in filtered_sequences_portion[portion][error]:
					aa = json.loads(new_lines[sequence])

					if type(redundant_lines[sequence]) == int:
						multiplication_factor = redundant_lines[sequence]
					else:
						multiplication_factor = len(redundant_lines[sequence])

					for framework in aa:
						if framework not in all_regions_aa[error]:
							all_regions_aa[error][framework] = {}
						for pos in aa[framework]:
							for ele in aa[framework][pos]:
								if pos not in all_regions_aa[error][framework]:
									all_regions_aa[error][framework][pos] = {}
								if ele in all_regions_aa[error][framework][pos]:
									all_regions_aa[error][framework][pos][ele] += multiplication_factor
								elif ele not in all_regions_aa[error][framework][pos]:
									all_regions_aa[error][framework][pos][ele] = multiplication_factor

		if chain == "H":
			print all_regions_aa[0]["fwh3"]["104"]
		else:
			print all_regions_aa[0]["fwl3"]["104"]

		
		print sum([correct_sequences[0][x][0] for x in correct_sequences[0]]) 
	
		print "Time took to analyse this file: ",time.time() - t1

		del filtered_sequences_portion
		del new_lines

	with open("YOUR_filtered_amino_acid_by_position.pkl", "wb") as s:
		pickle.dump(all_regions_aa, s, protocol=pickle.HIGHEST_PROTOCOL)
#
	with open("YOUR_filtered_sequenced.pkl", "wb") as s:
		pickle.dump(correct_sequences, s, protocol=pickle.HIGHEST_PROTOCOL)
	return correct_sequences  





if __name__ == '__main__':
	"Now this will run rather than your main"
	parser = OptionParser()
	parser.add_option("-f", "--file",
                  action="store", type="string", dest="filename")   # A file that will act as the redundant reference. Usually it is the file used as an input in run_file_1.py

	parser.add_option("-c", "--chain",
                  action="store", type="string", dest="chain", default="H")

	parser.add_option("-n", "--ncores", dest="ncores", type="int", default=2,
		          help="number of cores")

	parser.add_option("-q", "--server",
                  action="store", type="string", dest="server", default= "False", help="<If you run ABOSS on a machine with more than 64GB RAM indicate True to speed up ABOSS>")

	(options, args) = parser.parse_args()

	print "--------------------------------------"

	if options.ncores:
		ncores = options.ncores
		if options.server == "False": 
			if ncores > 8:
				ncores = 8
		else:
			if ncores > 12:
				ncores = 12
		print "The number of cores is set to %d " % (ncores)

	if options.filename:
		filename = options.filename
		print "The redundant file name is %s " % (filename)
	else:
		print "You did not indicate the filename"

	print "--------------------------------------"
	with open(filename, "rb") as read:
		redundant_lines = pickle.load(read)
	chain = options.chain

	flagResiduePositions(ncores)
