import cPickle as pickle
import csv
import os
from os.path import join
import shutil
import sys
csv.field_size_limit(sys.maxsize)

def convert_to_utf(list_inc):
	new_dict = {}
	if list_inc == [None]:
		return list_inc
	current_dict = dict(list_inc)
	for pos in current_dict:
		new_dict[pos.encode("utf-8")] = current_dict[pos].encode("utf-8")
	return new_dict

########################
### Open pickle file ###
########################
def writeOutputToCSV():
	cwd = os.getcwd()
	with open("YOUR_filtered_sequenced.pkl") as dd:
		data = pickle.load(dd)

	csv_dictonary = {}
	with open(join(cwd,"Temp_CSV","temporary.csv")) as csvDataFile:
	    csvReader = csv.reader(csvDataFile)
	    for row in csvReader:
		csv_dictonary[row[0]] = row[1],row[2],row[3],row[4],row[5]

	with open("Final_Ig-seq_information.csv", "wb") as csv_file:
		writer = csv.writer(csv_file, delimiter=',')
		header = "Sequence","Redundancy", "CDR-H3","Number of Flags", "Flagged Residue/Positions", "V Gene", "J Gene", "ANARCI Numbered Sequences","Query link"
		writer.writerow(header)
		for error in data:
			for seq in data[error]:
				  cdrh3 = csv_dictonary[seq][0]
				  V_gene = csv_dictonary[seq][1]
				  J_gene = csv_dictonary[seq][2]
				  aa = csv_dictonary[seq][3]
				  fasta_link = csv_dictonary[seq][4]
				  incorrect_positions = data[error][seq][1]
				  incorrect_positions_utf = convert_to_utf(incorrect_positions)
				  line = seq,data[error][seq][0],cdrh3, error, incorrect_positions_utf, V_gene, J_gene,aa,fasta_link
				  writer.writerow(line)

if __name__ == '__main__':
	writeOutputToCSV()
