#!/usr/bin/env python

from distutils.core import setup
import distutils

#                     		           #
# ANARCI was developed by James Dunbar     #
# Maintained by members of OPIG 	   #
#                               	   #

#We check if an user has an preinstalled version of ANARCI
try:
	import anarci
	anarci_status="PreInstalled"
except ImportError:
	anarci_status = "Clean"

setup(name='aboss',
      version='1.0',
      description='Filtering Ig-seq with structural information',
      author='Aleksandr Kovaltsuk',
      author_email='opig@stats.ox.ac.uk',
      url='http://opig.stats.ox.ac.uk//resources',

      packages=["aboss",'anarci', 'anarci.Bio', 'anarci.Bio.Align',

      'anarci.Bio.Alphabet', 'anarci.Bio.Data', 'anarci.Bio._py3k',
      'anarci.Bio.SearchIO','anarci.Bio.SearchIO._model', 'anarci.Bio.SeqIO', 'anarci.Bio.SearchIO.HmmerIO', 'anarci.Bio.AlignIO'  ],
      package_dir={"aboss":"lib/python/aboss",
		   'anarci': 'lib/python/anarci',
                   'anarci.Bio.AlignIO': 'lib/python/anarci/Bio/AlignIO', 
                   'anarci.Bio.SearchIO': 'lib/python/anarci/Bio/SearchIO', 
                   'anarci.Bio.SearchIO.HmmerIO': 'lib/python/anarci/Bio/SearchIO/HmmerIO', 
                   'anarci.Bio.Alphabet': 'lib/python/anarci/Bio/Alphabet', 
                   'anarci.Bio._py3k': 'lib/python/anarci/Bio/_py3k', 
                   'anarci.Bio.Data': 'lib/python/anarci/Bio/Data', 
                   'anarci.Bio': 'lib/python/anarci/Bio', 
                   'anarci.Bio.SearchIO._model': 'lib/python/anarci/Bio/SearchIO/_model', 
                   'anarci.Bio.SeqIO': 'lib/python/anarci/Bio/SeqIO',
                   'anarci.Bio.Align': 'lib/python/anarci/Bio/Align'},
      scripts=['bin/ANARCI', "bin/muscle","bin/ABOSS"],
      license="MIT"
     )
	

import sys
if sys.argv[1] != "install":
    sys.exit(0)

try:
	import aboss
except ImportError:
	print "The aboss package was put in the directory, which is not in your PATH variable! Please add the path, where ABOSS and ANARCI were put, to your PATH variable :)"
	sys.exit(1)

import anarci
import shutil,os,subprocess

os.chdir("build_pipeline")
proc = subprocess.Popen(["bash", "RUN_pipeline.sh"], stdout = subprocess.PIPE, stderr = subprocess.PIPE)
o, e = proc.communicate()

print o, e

print os.path.dirname(os.path.abspath(aboss.__file__) )

print os.path.dirname(anarci.__file__)

shutil.copy( "curated_alignments/germlines.py", os.path.dirname(anarci.__file__) )
distutils.dir_util.copy_tree( "HMMs", os.path.join(os.path.dirname( anarci.__file__ ), "dat/HMMs/") )

shutil.copy( "curated_alignments/germlines.py", os.path.dirname(aboss.__file__) )

if anarci_status=="PreInstalled":
	print "If there was an error message in the germline building step, Try to remove your current ANARCI version from your PATH variable and repeat the installation. P.S. the new version might have been installed in a different directory to where your version of ANARCI is located"
try:
	pr = subprocess.Popen( [ "ABOSS","-h" ], stdout=subprocess.PIPE, stderr=subprocess.PIPE )
	o, e = pr.communicate()
except OSError:
	print "ABOSS was put in the bin directory, which is not in your PATH variable!, Please alter your PATH variable accordingly"

